/* $Id: math_util.h,v 1.2 2005/11/23 17:21:16 jonathan Exp $
 * Jonathan Ledlie, Harvard University.
 * Copyright 2005.  All rights reserved.
 */

#ifndef MATH_UTIL_H
#define MATH_UTIL_H

//#include <sunmath.h>

#include <vector>
#include <algorithm>
#include <math.h>
#include <iostream>
using namespace::std;

#define Long long long

#define Rand() drand48()
#define SRand(c) srand48(c)
#define ABS(x) ((x > 0) ? x : -1*x)

double randPct ();
int poisson (int mean);
double poisson (double mean);
int unifRand (int a, int b);
double mean (vector<double> v);
double stddev (vector<double> v, double mean);
double percentile (vector<double> v, double percentile);
double square (double x);

#endif
