/* $Id: samples.h,v 1.6 2005/12/24 16:56:28 jonathan Exp $
 * Jonathan Ledlie, Harvard University.
 * Copyright 2005.  All rights reserved.
 */

#ifndef SAMPLES_H
#define SAMPLES_H

#include <deque>
#include "point.h"

class Samples {
  friend ostream& operator << (ostream& os, Samples *s);
 public:
  double ewma;
  //double previousSample;
  int jitterCount;
  int stamp;
  double weightedError;
  Point *vec;
  Point *appVector;
  deque<double> samples;
  Samples();
  ~Samples();
  double getSample ();
  void addSample (double sample, int myId, int yourId, 
		    Point *yourCoord, double yourWeightedError,
		    Point *yourAppCoord, int stamp);
  void print ();
};


#endif
