#define MAXNODE 2000
#include "stdio.h"
#include "stdlib.h"



int main (int argc, char **argv) 
{
	FILE *input_fp, *output_fp;
	static float input_matrix[MAXNODE][MAXNODE];
	int total_nodes = 0;
	int x, y;
	double z;
	int a;

	if (argc != 3)
	{
		printf("Usage: ./shortest_path matrix.txt matrix_SP.txt\n");	
		exit(1);
	}
	for(int ii=0;ii<MAXNODE;ii++)
		for(int jj=0;jj<MAXNODE;jj++)
			input_matrix[ii][jj] = -1;
		
	input_fp = fopen(argv[1], "r");
	output_fp = fopen(argv[2], "w");
	while (!feof(input_fp))
	{
		a = fscanf(input_fp, "%d %d %lf", &x, &y, &z);
		printf("%d ", a);
		if (x>total_nodes)
			total_nodes = x;
		if (y>total_nodes)
			total_nodes = y;
		input_matrix[x][y] = z;
		input_matrix[y][x] = z;
	}
	fclose(input_fp);
	printf ("Largest Node Number = %d\n", total_nodes);	
	for(int ii=0;ii<=total_nodes;ii++)
	{
		if ((ii % 100) == 0)
			printf("%d ", ii);
		for(int jj=0;jj<=total_nodes;jj++)
			for(int kk=0;kk<=total_nodes;kk++)
			{
				if (ii==jj || jj==kk || ii==kk)
					continue;
				if (input_matrix[ii][kk] < 0 || input_matrix[kk][jj] < 0)
					continue;
				if (input_matrix[ii][jj] > input_matrix[ii][kk] + input_matrix[kk][jj]
					|| input_matrix[ii][jj] < 0)
					input_matrix[ii][jj] = input_matrix[ii][kk] + input_matrix[kk][jj];
			}
	}
	for(int ii=0;ii<=total_nodes;ii++)
		for(int jj=0;jj<total_nodes;jj++)
			if (ii != jj && input_matrix[ii][jj] >= 0)
			{
				fprintf(output_fp, "%d %d %f\n", ii, jj, input_matrix[ii][jj]);
			}
	fclose(output_fp);

}

