#include "stdio.h"
#include "stdlib.h"

#define MAXNODE 3000
double matrix[MAXNODE][MAXNODE];
int node;

void Process(FILE *fp1)
{
	char s1[255];
	char s2[255];
	char s3[255];
	int i1, i2, i, j;
	float f;
	for(i=0;i<node;i++)
		for(j=0;j<node;j++)
			matrix[i][j] = -1;
 	while (fscanf (fp1, "%d %d %f", &i1, &i2, &f) > 0) {

		matrix[i1][i2] = f;
		matrix[i2][i1] = f;
	}
	fclose(fp1);
}

void Analysis()
{
	int i, j, k;
	int total1 = 0;
	int total2 = 0;

	int total3 = 0;
	int total4 = 0;

	int bad = 0;
	int ok = 0;
	double a, b, c;
	for(i=0;i<node;i++)
		for(j=0;j<node;j++)
		{
			if (matrix[i][j] < 0) continue;
			a = matrix[i][j];

			total3++;
			ok = 0;
			
			for(k=0;k<node;k++)
			{
				if (matrix[k][i] < 0 || matrix[j][k] < 0)
					continue;
				b = matrix[j][k]; c = matrix[k][i];
				total2++;
				if (total2 == 10000)
				{
					total2 = 0;
					total1++;
				}
				//printf("%.2f %.2f %.2f :", a, b, c);
				if (a+b<c)
				{
					//printf("bad");
					bad++;
					ok = 1;
				}
//				printf("\n");
			}
			if (ok == 1) total4++;
		}
	printf("Total = %d0000, Bad = %d\n", total1, bad);
	printf("Bad ratio  = %f\n", ((double)bad)/total1/10000*100);
	printf("Total = %d, Bad = %d\n", total3, total4);
	printf("Bad ratio (Strict) = %f\n", ((double)total4)/total3*100);
}

void printUsage()
{
	printf("./pickup NodeNumber InputFile\n");
	printf("[e.g.] ./pickup 2500 meridian\n");
	printf("[e.g.] ./pickup 1740 king.txt\n");
}


int main (int argc, char **argv) 
{

	FILE *inputfile;

	if (argc != 3)
	{
		printUsage();
		exit(0);
	}
	node = atoi(argv[1]);
	inputfile = fopen(argv[2], "r");
	Process(inputfile);
	fclose(inputfile);
	Analysis();
	return 0;	
}

